SystemOrganization addCategory: #ConfigurationOfPhantom!

Object subclass: #ConfigurationOfPhantom
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfPhantom'!

!ConfigurationOfPhantom classSide methodsFor: 'development support' stamp: 'DanielGaldames 4/14/2011 13:00'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfPhantom classSide methodsFor: 'private' stamp: 'DanielGaldames 4/14/2011 13:00'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfPhantom classSide methodsFor: 'private' stamp: 'DanielGaldames 4/14/2011 13:00'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfPhantom classSide methodsFor: 'private' stamp: 'DanielGaldames 4/14/2011 13:00'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfPhantom classSide methodsFor: 'metacello tool support' stamp: 'DanielGaldames 4/14/2011 13:00'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfPhantom classSide methodsFor: 'loading' stamp: 'DanielGaldames 4/14/2011 13:00'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfPhantom classSide methodsFor: 'loading' stamp: 'DanielGaldames 4/14/2011 13:00'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfPhantom classSide methodsFor: 'loading' stamp: 'DanielGaldames 4/14/2011 13:00'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfPhantom classSide methodsFor: 'accessing' stamp: 'DanielGaldames 4/14/2011 13:00'!
project

	^self new project! !

!ConfigurationOfPhantom classSide methodsFor: 'development support' stamp: 'DanielGaldames 4/14/2011 13:00'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfPhantom methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/20/2011 20:35'!
baseline10: spec
	<version: '1.0-baseline'>
		spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://www.squeaksource.com/Phantom'.

		spec
			package: 'Phantom-Core' with: [spec requires: #('PetitParser' 'Phantom-PrecedenceGraph' 'MethodWrappers' 'RBParser')];
			package: 'PetitParser' with: [spec repository: 'http://source.lukas-renggli.ch/petit'];
			package: 'RBParser' with: [spec repository: 'http://www.squeaksource.com/rb'];
			package: 'MethodWrappers' with: [spec repository: 'http://www.squeaksource.com/ObjectMetaTools'];
			package: 'Phantom-PrecedenceGraph';
			package: 'Phantom-Tests' with: [ spec requires: #('Phantom-Core')];
			package: 'Phantom-Examples' with: [ spec requires: #('Phantom-Core')];
			package: 'Phantom-PrecedenceGraphTests' with: [ spec requires: #('Phantom-PrecedenceGraph')].
		
		spec
			group: 'default' with: #('Phantom-Core' 'Phantom-Examples');
			group: 'Core' with: #('Phantom-Core');
			group: 'Tests' with: #('Phantom-Tests' 'Phantom-PrecedenceGraphTests').
		]
! !

!ConfigurationOfPhantom methodsFor: 'symbolic versions' stamp: 'DanielGaldames 4/19/2011 17:29'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.2'.
! !

!ConfigurationOfPhantom methodsFor: 'accessing' stamp: 'DanielGaldames 4/14/2011 13:00'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfPhantom methodsFor: 'symbolic versions' stamp: 'DanielGaldames 4/19/2011 17:28'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.1'.
! !

!ConfigurationOfPhantom methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/20/2011 20:37'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline')>
	spec for: #common do: [
		spec blessing: #release.
		spec package: 'PetitParser' with: 'PetitParser-lr.211'.
		spec package: 'RBParser' with: 'AST-Core-lr.87'.
		spec package: 'MethodWrappers' with: 'MethodWrappers-MarianoMartinezPeck.6'.
		spec package: 'Phantom-Core' with: 'Phantom-Core-DanielGaldames.1'.
		spec package: 'Phantom-Tests' with: 'Phantom-Tests-DanielGaldames.6'.
		spec package: 'Phantom-Examples' with: 'Phantom-Examples-DanielGaldames.2'.
		spec package: 'Phantom-PrecedenceGraph' with: 'Phantom-PrecedenceGraph-DanielGaldames.1'.
		spec package: 'Phantom-PrecedenceGraphTests' with: 'Phantom-PrecedenceGraphTests-DanielGaldames.1'.]! !

!ConfigurationOfPhantom methodsFor: 'versions' stamp: 'DanielGaldames 4/20/2011 20:37'!
version11: spec
	<version: '1.1' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec description: 'advices are build on install for the method wrapper
1.1 (): advice manipulation
1.1 (): recategorization adviceIndex on context
1.1 (): 
	- change advices to advice.
	- fix bug in change order of an advice in other advice
- added inheritance precedence
- added tests'.
		spec author: 'DanielGaldames'.
		spec timestamp: '4/19/2011 16:42'.
		spec 
			package: 'PetitParser' with: 'PetitParser-lr.211';
			package: 'RBParser' with: 'AST-Core-lr.87';
			package: 'MethodWrappers' with: 'MethodWrappers-MarianoMartinezPeck.6';
			package: 'Phantom-Core' with: 'Phantom-Core-DanielGaldames.6';
			package: 'Phantom-Tests' with: 'Phantom-Tests-DanielGaldames.9';
			package: 'Phantom-Examples' with: 'Phantom-Examples-DanielGaldames.2';
			package: 'Phantom-PrecedenceGraph' with: 'Phantom-PrecedenceGraph-DanielGaldames.1';
			package: 'Phantom-PrecedenceGraphTests' with: 'Phantom-PrecedenceGraphTests-DanielGaldames.1'. ].
! !

!ConfigurationOfPhantom methodsFor: 'versions' stamp: 'DanielGaldames 4/20/2011 20:37'!
version12: spec
	<version: '1.2' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: ''.
		spec author: 'DanielGaldames'.
		spec timestamp: '4/19/2011 17:29'.
		spec 
			package: 'PetitParser' with: 'PetitParser-lr.211';
			package: 'RBParser' with: 'AST-Core-lr.87';
			package: 'MethodWrappers' with: 'MethodWrappers-MarianoMartinezPeck.6';
			package: 'Phantom-Core' with: 'Phantom-Core-DanielGaldames.6';
			package: 'Phantom-Tests' with: 'Phantom-Tests-DanielGaldames.9';
			package: 'Phantom-Examples' with: 'Phantom-Examples-DanielGaldames.2';
			package: 'Phantom-PrecedenceGraph' with: 'Phantom-PrecedenceGraph-DanielGaldames.1';
			package: 'Phantom-PrecedenceGraphTests' with: 'Phantom-PrecedenceGraphTests-DanielGaldames.1'. ].
! !
